## Call any needed libraries
library(stats)
library(rugarch)

### Set initial values
omegasim=2
alpha1sim=0
gamma1sim=0.05
beta1sim=.1
ar1=0.8
ar2=-0.2
ar3=0.1
ar4=0
ar5=0
ar6=0
ar7=0
ar8=0
ar9=0
ar10=0
ar11=0
ar12=0
ar13=0
ar14=0
ar15=0
ar16=0
ar17=0
ar18=0
ar19=0
ar20=0
ar21=0
ar22=0
ar23=0
ar24=0
ar25=0

end=80*365
time=seq(1,end,by=1)
df=rep(1:365,100)[1:end]
xvreg=cbind(sin(2*pi*df/365), cos(2*pi*df/365),sin(4*pi*df/365), cos(4*pi*df/365),sin(6*pi*df/365), cos(6*pi*df/365))

vs1sim=1
vc1sim=.8
vs2sim=-.3
vc2sim=.1
vs3sim=.1
vc3sim=-.1
vparsim=c(vs1sim, vc1sim, vs2sim, vc2sim, vs3sim, vc3sim)

## Prepare the simulations
as = rep(0, end)
lhs = rep(1, end)
Zs = rep(0, end)

spec.fit <- ugarchspec(mean.model=list(armaOrder=c(25,0), include.mean=FALSE),
                       variance.model=list(model="eGARCH", garchOrder=c(1,1),
                                           external.regressors=xvreg[,1:6], variance.targeting=FALSE),
                       distribution.model = "norm")

## This simulates and fits within a single loop
parmrugarch <- numeric()



for (k in 1:1) {
  cat(k," ")
  wspast=rnorm(end,0,1)
  for (j in 26:end) {
    lhs[j] = omegasim + gamma1sim * (abs(wspast[j-1]) - sqrt(2/pi)) +
      alpha1sim*wspast[j-1] + beta1sim * lhs[j-1] + (xvreg%*%vparsim)[j]
    as[j] = wspast[j]*sqrt(exp(lhs[j]))
    Zs[j] = ar1*Zs[j-1] +
      ar2*Zs[j-2] +
      ar3*Zs[j-3] +
      ar4*Zs[j-4] +
      ar5*Zs[j-5] +
      ar6*Zs[j-6] +
      ar7*Zs[j-7] +
      ar8*Zs[j-8] +
      ar9*Zs[j-9] +
      ar10*Zs[j-10] +
      ar11*Zs[j-11] +
      ar12*Zs[j-12] +
      ar13*Zs[j-13] +
      ar14*Zs[j-14] +
      ar15*Zs[j-15] +
      ar16*Zs[j-16] +
      ar17*Zs[j-17] +
      ar18*Zs[j-18] +
      ar19*Zs[j-19] +
      ar20*Zs[j-20] +
      ar21*Zs[j-21] +
      ar22*Zs[j-22] +
      ar23*Zs[j-23] +
      ar24*Zs[j-24] +
      ar25*Zs[j-25] +
      as[j]
  }
  asfit=as[731:end]
  lhsfit=lhs[731:end]
  Zsfit=Zs[731:end]
  # out=optim(c(15,.15,.15,3,3),fr)$par ## comment out to simulate only
  # parmrob <- rbind(parmrob,out) ## comment out to simulate only
  # fit <- ugarchfit(data=Zsfit, spec=spec.fit, solver="hybrid")
  ## fit2 <- ugarchfit(data=Zsfit, spec=spec.fit, solver="hybrid")
  parmrugarch <- rbind(parmrugarch,coef(fit))
}

par(mfrow=c(1,5))
plot(Zsfit[1:1500], type="l", xlab="Day",ylab="Sim. Process")
plot(Zsfit[1:1500]^2, type="l", xlab="Day",ylab="Squared Sim. Process")
plot(sqrt(exp(lhsfit[1:1500])), type="l", xlab="Day",ylab="Conditional St. Dev.")

#write.csv(parmrugarch, file="parmrugarchFullEGARCH.csv")

##########################################
parmrugarch=read.csv(file="parmrugarchFullEGARCHRewrite.csv")

parmrugarch=data.frame(parmrugarch)

## Investigate some of the fits here
keeperh=numeric()
keeperz=numeric()

for (k in 1:250) {
  cat(k," ")
  # k=8
  ar1c=parmrugarch$ar1[k]
  ar2c=parmrugarch$ar2[k]
  ar3c=parmrugarch$ar3[k]
  ar4c=parmrugarch$ar4[k]
  ar5c=parmrugarch$ar5[k]
  ar6c=parmrugarch$ar6[k]
  ar7c=parmrugarch$ar7[k]
  ar8c=parmrugarch$ar8[k]
  ar9c=parmrugarch$ar9[k]
  ar10c=parmrugarch$ar10[k]
  ar11c=parmrugarch$ar11[k]
  ar12c=parmrugarch$ar12[k]
  ar13c=parmrugarch$ar13[k]
  ar14c=parmrugarch$ar14[k]
  ar15c=parmrugarch$ar15[k]
  ar16c=parmrugarch$ar16[k]
  ar17c=parmrugarch$ar17[k]
  ar18c=parmrugarch$ar18[k]
  ar19c=parmrugarch$ar19[k]
  ar20c=parmrugarch$ar20[k]
  ar21c=parmrugarch$ar21[k]
  ar22c=parmrugarch$ar22[k]
  ar23c=parmrugarch$ar23[k]
  ar24c=parmrugarch$ar24[k]
  ar25c=parmrugarch$ar25[k]
  
  omc=parmrugarch$omega[k]
  alc=parmrugarch$alpha1[k]
  bec=parmrugarch$beta1[k]
  gac=parmrugarch$gamma1[k]
  vs1c=parmrugarch$vxreg1[k]
  vc1c=parmrugarch$vxreg2[k]
  vs2c=parmrugarch$vxreg3[k]
  vc2c=parmrugarch$vxreg4[k]
  vs3c=parmrugarch$vxreg5[k]
  vc3c=parmrugarch$vxreg6[k]
  vparc=c(vs1c,vc1c,vs2c, vc2c, vs3c, vc3c)
  
  asc = rep(0, end)
  lhsc = rep(2, end)
  Zsc = rep(0, end)
  
  wspast=rnorm(end,0,1)
  for (j in 26:end) {
    lhsc[j] = omc + gac * (abs(wspast[j-1]) - sqrt(2/pi)) + alc*wspast[j-1] + bec * lhsc[j-1] + (xvreg%*%vparc)[j]
    asc[j] = wspast[j]*sqrt(exp(lhsc[j]))
    Zsc[j] = ar1c*Zsc[j-1] +
      ar2c*Zsc[j-2] +
      ar3c*Zsc[j-3] +
      ar4c*Zsc[j-4] +
      ar5c*Zsc[j-5] +
      ar6c*Zsc[j-6] +
      ar7c*Zsc[j-7] +
      ar8c*Zsc[j-8] +
      ar9c*Zsc[j-9] +
      ar10c*Zsc[j-10] +
      ar11c*Zsc[j-11] +
      ar12c*Zsc[j-12] +
      ar13c*Zsc[j-13] +
      ar14c*Zsc[j-14] +
      ar15c*Zsc[j-15] +
      ar16c*Zsc[j-16] +
      ar17c*Zsc[j-17] +
      ar18c*Zsc[j-18] +
      ar19c*Zsc[j-19] +
      ar20c*Zsc[j-20] +
      ar21c*Zsc[j-21] +
      ar22c*Zsc[j-22] +
      ar23c*Zsc[j-23] +
      ar24c*Zsc[j-24] +
      ar25c*Zsc[j-25] +
      asc[j]
  }
  asc=asc[731:end]
  lhsc=lhsc[731:end]
  Zsc=Zsc[731:end]
  keeperz=rbind(keeperz,Zsc[1:1500])
  keeperh=rbind(keeperh,lhsc[1:1500])
}

## Figure will be made here:
dev.off()
par(mfrow=c(1,5))
plot(Zsfit[1:1500], type="l", xlab="Day",ylab="Sim. Process",main="A: Realization")
plot(Zsfit[1:1500]^2, type="l", xlab="Day",ylab="Squared Sim. Process",main="B: Realization")
plot(sqrt(exp(lhsfit[1:1500])), type="l", xlab="Day",ylab="Conditional St. Dev.",main="C: Realization")


b01h=array()
b25h=array()
b50h=array()
b75h=array()
b99h=array()

for (i in 1:1500){
  b01h[i]=quantile(sqrt(exp(keeperh[,i])),0.01)
  b25h[i]=quantile(sqrt(exp(keeperh[,i])),0.25)
  b50h[i]=quantile(sqrt(exp(keeperh[,i])),0.50)
  b75h[i]=quantile(sqrt(exp(keeperh[,i])),0.75)
  b99h[i]=quantile(sqrt(exp(keeperh[,i])),0.99)
}
b01z=array()
b25z=array()
b50z=array()
b75z=array()
b99z=array()

for (i in 1:1500){
  b01z[i]=quantile(keeperz[,i],0.01)
  b25z[i]=quantile(keeperz[,i],0.25)
  b50z[i]=quantile(keeperz[,i],0.50)
  b75z[i]=quantile(keeperz[,i],0.75)
  b99z[i]=quantile(keeperz[,i],0.99)
}

#plot(Zsfit[1:1500], type="l",ylim=c(-20,20))
#plot(sqrt(exp(lhsfit[1:1500])), type="l", ylim=c(0,10))
#plot(Zsc[1:1500], type="l",ylim=c(-20,20))
#plot(sqrt(exp(lhsc))[1:1500], type="l", ylim=c(0,10))

plot(b01z, ylim=c(-30,30), cex=0.3, lty=3, type="l", main="D: Fitted Error Process",xlab="Day",ylab="")
points(b25z, cex=0.3, type="l", lty=2)
points(b50z, cex=0.3, type="l", lty=1)
points(b75z, cex=0.3, type="l", lty=2)
points(b99z, cex=0.3, type="l", lty=3)

plot(b01h, ylim=c(0,7), cex=0.3, lty=3, type="l", main="E: Fitted Conditional StDev",xlab="Day",ylab="")
points(b25h, cex=0.3, type="l",lty=2)
points(b50h, cex=0.3, type="l")
points(b75h, cex=0.3, type="l", lty=2)
points(b99h, cex=0.3, type="l", lty=3)



#########################################
## Remake simulation Figure
#########################################
parmrugarch=read.csv(file="parmrugarchFullEGARCHRewrite.csv")
parmrugarch=data.frame(parmrugarch)

postscript(file="hist2.eps", width=1000)
par(mfrow=c(5,4), mar=c(1.2,2,1.2,2), oma=c(1,1,1,1))
boxplot(parmrugarch$omega,main="omega"); abline(h=0.5,col="red", lwd=2)
boxplot(parmrugarch$alpha1,main="alpha1",ylim=c(0.02,0.08)); abline(h=0.05,col="red", lwd=2)
boxplot(parmrugarch$alpha2,main="alpha2",ylim=c(0.02,0.08)); abline(h=0.05,col="red", lwd=2)
boxplot(parmrugarch$alpha3,main="alpha3",ylim=c(0.02,0.08)); abline(h=0.05,col="red", lwd=2)
boxplot(parmrugarch$beta1,main="beta"); abline(h=0.8,col="red", lwd=2)
boxplot(parmrugarch$gamma1,main="gamma1"); abline(h=0.1,col="red", lwd=2)
boxplot(parmrugarch$gamma2,main="gamma2"); abline(h=-0.05,col="red", lwd=2)
boxplot(parmrugarch$gamma3,main="gamma3"); abline(h=-0.05,col="red", lwd=2)
boxplot(parmrugarch$ar1,main="ar1"); abline(h=0.8,col="red", lwd=2)
boxplot(parmrugarch$ar2,main="ar2"); abline(h=-0.2,col="red", lwd=2)
boxplot(parmrugarch$ar3,main="ar3"); abline(h=0.1,col="red", lwd=2)
boxplot(parmrugarch$vxreg1,main="gamma sin1"); abline(h=0.2,col="red", lwd=2)
boxplot(parmrugarch$vxreg2,main="gamma cos1"); abline(h=0.1,col="red", lwd=2)
boxplot(parmrugarch$vxreg3,main="gamma sin2",ylim=c(-0.07,-0.03)); abline(h=-0.05,col="red", lwd=2)
boxplot(parmrugarch$vxreg4,main="gamma cos2",ylim=c(0.03,0.07)); abline(h=0.05,col="red", lwd=2)
boxplot(parmrugarch$vxreg5,main="gamma sin3",ylim=c(-0.01,0.01)); abline(h=0,col="red", lwd=2)
boxplot(parmrugarch$vxreg6,main="gamma cos3"); abline(h=0,col="red", lwd=2)
dev.off()

dev.off()
par(mfrow=c(1,2))
plot(parmrugarch$omega, parmrugarch$beta1, xlab="Omega", ylab="Beta",
     sub=paste("Correlation is",round(cor(parmrugarch$omega, parmrugarch$beta1),3)))
plot(parmrugarch$vxreg1, parmrugarch$vxreg3, xlab="Gamma Sin1", ylab="Gamma Sin2",
     sub=paste("Correlation is",round(cor(parmrugarch$vxreg1, parmrugarch$vxreg3),3)))